Status: Resolved Priority: Should have
Author: Bastian Waidelich Category: MVC - Routing
PHP Version:
Has patch: No
Subject: Functional routing tests
Description

Some important routing features urgently need functional tests

Associated revisions
Revision 6c9633fa - 2012-07-03 16:11 - Bastian Waidelich

[TASK] Functional tests for Routing Framework

Adds testing routes to the provided Testing/Routes.yaml
file and adds tests covering mathing and resolving of
arbitrary routes.

Change-Id: Icd1b2efb06d183ba29ee5f375d62cc02a2f84f69
Resolves: #37608
Releases: 1.1, 1.2

Revision 593f84a2 - 2012-07-03 16:15 - Bastian Waidelich

[TASK] Functional tests for Routing Framework

Adds testing routes to the provided Testing/Routes.yaml
file and adds tests covering mathing and resolving of
arbitrary routes.

Change-Id: Icd1b2efb06d183ba29ee5f375d62cc02a2f84f69
Resolves: #37608
Releases: 1.1, 1.2

History
#1 - 2012-06-19 16:00 - Bastian Waidelich
- Target version changed from 1.1 RC1 to 1.1

Almost ready, but not completely.. ;)

#2 - 2012-06-25 16:44 - Karsten Dambekalns
Any news on this one?

#3 - 2012-06-26 15:12 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12379

#4 - 2012-06-26 15:13 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12380

#5 - 2012-06-27 16:11 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12379

#6 - 2012-07-03 16:12 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12379

#7 - 2012-07-03 16:17 - Gerrit Code Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12380

#8 - 2012-07-06 14:49 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:593f84a214b8ac1f432681d2aa74872b86857ea4.

#9 - 2012-07-09 18:05 - Christopher Hlubek

I get errors in an HTTP functional test for FLOW3 1.1 after this change. I know this worked last week in a demo application:

Uncaught Exception in FLOW3 #1301650951: No controller object was found for package "myvendor.mypackage", subpackage
"Tests\Functional\Mvc\Fixtures", controller "login" in route "FLOW3 :: Functional Test: controller route parts are case insensitive".
thrown in file
.../Data/Temporary/Testing/Cache/Code/FLOW3_Object_Classes/TYPO3_Fluid_ViewHelpers_Link_ActionViewHelper_Original.php
in line 90
I'm just generating a link inside a Fluid template (<f:link.action action="index" controller="Login">Login</f:link.action>) of a Standard controller in an
indexAction.

The problem seems to be the route "FLOW3 :: Functional Test: controller route parts are case insensitive" which throws an exception after merging the
given route values (which do not contain a subpackage) on the defaults (which define a subpackage Tests\Functional\...) because a controller with that
name could not be found (which is correct, since the LoginController does not exist for subpackage Test\Functional\Mvc\Fixtures).

So either we have to fix the subpackage override (no or NULL subpackage overrides a given subpackage) or disable the exception and just return
FALSE in resolves(...) if the controller object is not found.
